
void threeRings1() {
  for (int count = 10; count < 15; count++) {
    for (int ring = 0; ring < 24; ring++) {
      int ring2, ring3, ring4;
      if (ring < 12) ring2 = ring;
      else ring2 = 23 - ring;
      if (ring > 7  && ring < 20) ring3 = ring - 8;
      if (ring < 9) ring3 = 8 - ring;
      if (ring > 19) ring3 = 31 - ring;
      if (ring > 15) ring4 = ring - 16;
      if (ring < 4) ring4 = ring + 8;
      if (ring > 3 && ring < 16) ring4 = 15 - ring;
      setRing(ring2, 0);
      if (count > 4) setRing(ring3, 167);
      if (count > 9) setRing(ring4, 83);
      showClear(15 + count * 4);
    }
  }
  pause();
}

void threeRings2() {
  int pos = 0;
  int dir = 1;
  for (int count = 0; count < 16; count++) {
    for (int j = 0; j < 12; j++) {
      for (int i = 0; i < 12; i++) {
        if (pgm_read_word_near(&plane[8][11 - j]) & (1 << i)) {
          setStd(j + 2, i, Red);
          setStd(j + 2, 23 - i, Red);
        }
      }
    }

    for (int i = 0; i < 23; i++) {
      for (int m = 0; m < 12; m++) {
        rotate(m, 0);
      }
      showKeep(5);
    }

    clearAll();
    setRing(pos, 83);
    setRing(11 - pos, 167);
    pos = pos + dir;
    if (pos == -1) {
      pos = 1;
      dir = +1;
    }
    if (pos == 12) {
      pos = 10;
      dir = -1;
    }
    showKeep(1);
  }
  pause();
}

void shiftingPlanes() {
  int mydelay = 5;
  for (int count = 0; count < 1; count++) {
    for (int k = 1; k < 9; k++) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {
          if (pgm_read_word_near(&plane[k][11 - j]) & (1 << i)) {
            setHue(j, i, myhue);
            setHue(j, 23 - i, myhue);
          }
        }
      }
      for (int i = 0; i < 23; i++) {
        for (int m = 0; m < 12; m++) {
          rotate(m, 0); // clockwise
        }
        showKeep(mydelay);
      }
      clearAll();
      myhue += 3;
    }
    for (int k = 1; k < 4; k++) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {
          if (pgm_read_word_near(&plane[8][11 - j]) & (1 << i)) {
            setHue(j + k, i, myhue);
            setHue(j + k, 23 - i, myhue);
          }
        }
      }
      for (int i = 0; i < 23; i++) {
        for (int m = 0; m < 12; m++) {
          rotate(m, 0); // clockwise
        }
        showKeep(mydelay);
      }
      if (k < 3)clearAll();
      myhue += 3;
    }
    for (int i = 0; i < 12; i++) {
      for (int m = 0; m < 12; m++) {
        rotate(m, 0); // clockwise
      }
      showKeep(mydelay);
    }
    clearAll();
    myhue += 3;
    for (int k = 7; k > 1; k--) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {
          if (pgm_read_word_near(&plane[k][j]) & (1 << i)) {
            setHue(j, i, myhue);
            setHue(j, 23 - i, myhue);
          }
        }
      }
      for (int i = 0; i < 23; i++) {
        for (int m = 0; m < 12; m++) {
          rotate(m, 0); // clockwise
        }
        showKeep(mydelay);
      }
      clearAll();
      myhue += 3;
    }

    for (int k = 1; k < 8; k++) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {
          if (pgm_read_word_near(&plane[k][j]) & (1 << i)) {
            setHue(j, i, myhue);
            setHue(j, 23 - i, myhue);
          }
        }
      }
      for (int i = 0; i < 23; i++) {
        for (int m = 0; m < 12; m++) {
          rotate(m, 0); // clockwise
        }
        showKeep(mydelay);
      }
      if (k < 7)clearAll();
      myhue += 3;
    }

    for (int i = 0; i < 12; i++) {
      for (int m = 0; m < 12; m++) {
        rotate(m, 0); // clockwise
      }
      showKeep(mydelay);
    }
    clearAll();
    myhue += 3;

    for (int k = 3; k > 0; k--) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {
          if (pgm_read_word_near(&plane[8][11 - j]) & (1 << i)) {
            setHue(j + k, i, myhue);
            setHue(j + k, 23 - i, myhue);
          }
        }
      }
      for (int i = 0; i < 23; i++) {
        for (int m = 0; m < 12; m++) {
          rotate(m, 0); // clockwise
        }
        showKeep(mydelay);
      }
      clearAll();
      myhue += 3;
    }

    for (int k = 8; k > 1; k--) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {
          if (pgm_read_word_near(&plane[k][11 - j]) & (1 << i)) {
            setHue(j, i, myhue);
            setHue(j, 23 - i, myhue);
          }
        }
      }
      for (int i = 0; i < 23; i++) {
        for (int m = 0; m < 12; m++) {
          rotate(m, 0); // clockwise
        }
        showKeep(mydelay);
      }
      clearAll();
      myhue += 3;
    }
  }
}

void wireframe() {
  byte k1, k2, k3;
  for (int k = 0; k < 50; k++) {
    myhue += 5;
    k1 = k % 24;
    k2 = k % 24 + 8; if (k2 > 23) k2 = k2 - 24;
    k3 = k % 24 + 16; if (k3 > 23) k3 = k3 - 24;
    setRing(11, myhue);
    setRing(0, myhue);
    setCol(k1, myhue);
    setCol(k2, myhue);
    setCol(k3, myhue);
    setStd(11, k1, Black);
    setStd(11, k2, Black);
    setStd(11, k3, Black);
    setStd(0, k1, Black);
    setStd(0, k2, Black);
    setStd(0, k3, Black);
    for (int j = 0; j < 12; j++) {
      rotate(j, 0); // clockwise
    }
    showKeep(75);
  }
  pause();
}

void towerFades() {
  for (int j = 0; j < 50; j++) {
    myhue++;
    if (myhue % 2 == 0)setRing(random(12), 21 * random(12));
    setCol(random(24), 21 * random(12));
    showKeep(100);
    fadeAll(150);
  }
  pause();
}

// Rings rotate in opposite directions and fade
void doubleFade() {
  for (int i = 0; i < 4; i++) {
    for (int k = 0; k < 24; k++) {
      for (int j = 0; j < 12; j++) {
        if (j % 2)setStd(j, k, Green);
        else setStd(j, 23 - k, Blue);
      }
      showKeep(50);
      fadeAll(150);
    }
  }
  pause();
}

// spiral demo
// parameters: degree of spiral, color, # of rotations, delay, dir of rotation, dir of spiral
// works up to one full revolution; e.g degree 7 with 7 rings int(49/2)=24; 4 with 12 rings (4*12)/2=24
void spiralDemo() {
 // spiral(1, Yellow, 5, 25, 0, 1);
  //spiral(2, Green, 5, 25, 0, 0);
 // spiral(3, Aqua, 5, 25, 0, 1);
  spiral(4, Red, 5, 25, 0, 0);
//  spiral(4, Blue, 5, 75, 1, 1);
}
